project/models/user.py
from .. import db
from flask_login import UserMixin
from werkzeug.security import check_password_hash

class User(UserMixin, db.Model):
    __tablename__ = 'user'
    id = db.Column(db.Integer, primary_key=True, autoincrement=True)
    username = db.Column(db.String(80), unique=True)
    email = db.Column(db.String(120), unique=True)
    password = db.Column(db.String(200))
    fullname = db.Column(db.String(100))
    profile_image = db.Column(db.String(50))
    role = db.Column(db.String(10))
    addresses = db.relationship('Address', backref='user', lazy="dynamic")
    orders = db.relationship('Order', backref='user', lazy="dynamic")

    def __init__(self, username, email, password, fullname, profile_image, role):
        self.username = username
        self.email = email
        self.password = password
        self.fullname = fullname
        self.profile_image = profile_image
        self.role = role

    def __repr__(self):
        return '<User %r, Email %r>' % (self.username, self.email)
    
    def is_admin(self):
        if self.role == 'admin':
            return True
        return False

    def get_profile(self):
        return {
            "username" : self.username,
            "email" : self.email,
            "fullname" : self.fullname,
            "profile_image" : self.profile_image,
            "role" : self.role,
        }

    def verify_password(self, pwd):    
        return check_password_hash(self.password, pwd)


class Address(db.Model):
    id = db.Column(db.Integer, primary_key=True, autoincrement=True)
    name = db.Column(db.String(100), nullable=False)
    address = db.Column(db.String(500), nullable=False)
    country = db.Column(db.String(500), nullable=False)
    postcode = db.Column(db.String(20), nullable=False)
    user_id = db.Column(db.Integer, db.ForeignKey('user.id'), nullable=False)
    phone = db.Column(db.String(10))

    def __init__(self, name, address, country, postcode, user_id, phone):
        self.name = name
        self.address = address
        self.country = country
        self.postcode = postcode
        self.user_id = user_id
        self.phone = phone


class Message(db.Model):
    __tablename__ = 'message'
    id = db.Column(db.Integer, primary_key=True, autoincrement=True)
    message = db.Column(db.String(500), nullable=False)
    sender = db.Column(db.String(30), nullable=False)
    user_id = db.Column(db.Integer, db.ForeignKey('user.id'), nullable=False)
    time = db.Column(db.String(50))
    user = db.relationship('User', backref='messages')

    def __init__(self, message, sender, user_id, time):
        self.message = message
        self.sender = sender
        self.user_id = user_id
        self.time = time

project/routes/user.py
from flask import Blueprint,request, render_template, redirect, url_for, session, current_app
from flask_login import login_required, current_user
from ..services.user import UserService

import os

# @socketio.on('my event')
# def handle_my_custom_event(json):
#     print('received json: ' + str(json))

user = Blueprint('user', __name__)

@user.route('/')
def home():
    return render_template("home.html")


@user.route('/register', methods=["GET","POST"])
def register():
    if request.method == 'POST':
        return UserService.register(request)
    elif request.method == 'GET':
        if current_user.is_authenticated:
            return redirect(url_for('user.home'))
        else:
            return render_template("user/register.html")


@user.route('/login', methods=["GET","POST"])
def login():
    if request.method == 'POST':
        return UserService.login(request)
    elif request.method == 'GET':
        if current_user.is_authenticated:
            return redirect(url_for('user.home'))
        else:
            return render_template("user/login.html")


@user.route('/profile', methods=["GET"])
@login_required
def profile():
    if request.method == 'GET':
        return render_template("user/profile.html")


@user.route('/update_profile', methods=["POST"])
@login_required
def update_profile():
    return UserService.update_profile(request)

@user.route('/update_profile/image', methods=["POST"])
@login_required
def upload_image_profile():
    if request.method == 'POST':
        return UserService.update_profile_image(request)


@user.route('/address/add', methods=["POST"])
@login_required
def add_address():
    if request.method == 'POST':
        return UserService.add_address(request)


@user.route('/logout', methods=["POST"])
@login_required
def logout():
    if request.method == 'POST':
        return UserService.logout()

project/templates/user/login.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Oganikku</title>
    <!-- CSS only -->
<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">
</head>
<style>
    body{
        margin: 0px;
    }
    .bg-container{
    background: rgba(0,0,0,0.7) url(static/images/loginbg.jpg);
    background-blend-mode: darken;
    height: 100vh;
    width: 100%;
    background-repeat: no-repeat;
    background-size: 100vw 100vh;
    }
    .form-container{
        padding-top: 7%;
    }
    input {
        border-top-style: hidden;
        border-right-style: hidden;
        border-left-style: hidden;
        border-bottom-style: solid;
        border-bottom-color: white;
        background-color: transparent;
        width: 100%;
        height: 50px;
      }
      
      .no-outline:focus {
        outline: none;
   
      }
      .btn-login{
        width: 400px;
        background-color: #A9D18E;
        padding: 20px;
        border-radius: 30px;
        font-size: 20px;
        cursor: pointer;
        display: flex;
        text-align: center;
        justify-content: center;
        margin-left: auto;
        margin-right: auto;
      }
    .btn-create-account{
        margin-top:2%;
        font-family: Century Gothic;
        font-weight: bold;
        font-size:20px;
        text-align: center;
        color: white;
        cursor: pointer;
        margin-left: auto;
        margin-right: auto;
        display: flex;
        justify-content: center;
    }
</style>



<body > 
   <div class="bg-container">
        <div class="form-container">
                <div style="color: white;text-align: center; font-size: 30px;font-family: Century Gothic;">
                    welcome block
                </div>
                <div style="color:white;text-align: center;font-size: 50px;font-weight: bold;font-family:Century Gothic;">
                    Login Your Account
                </div>
                <center> 
                <div style="
                    margin-top:3%;
                    width:470px;
    
                    text-align: left;"
                    >
                    <form action="/login" method="POST">
                        <p style="color:white;font-size: 20px;margin-bottom:2px;">Email</p>
                        <input type="email" name="email" class="no-outline" placeholder="Email@mail.com"
                        autocomplete="off" required
                        style="color: white;">
                        <p style="color: white;font-size: 20px;margin-bottom:2px;margin-top:3%;">Password</p>
                        <input type="password" required name="password"  autocomplete="off" class="no-outline" placeholder="Password" style="color:white;">
                    
                        <div style="width: 100%;">
                        {% with messages = get_flashed_messages() %}
                        {% if messages %}
                            <ul class=flashes style="margin-top:3%;text-align: center;color: red; font-family: Century Gothic;font-weight: bold;padding-left: 0px;">
                            {{ messages[0] }}
                            </ul>
                        {% endif %}
                        {% endwith %}
                    </div>
                      
                        <button type="submit" class="btn-login" style="margin-top:3%;color:white;">
                            Login
                        </button>
                    </form>
                </div>
        
            <a href="{{url_for('user.register')}}" style="text-decoration: none;">
                <div class="btn-create-account">
                    Crate New Account ?
                </div>
            </a>
        </center>
        </div>
    </div>

</body>
</html>
<script>

</script>

project/templates/user/message.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Oganikku</title>

    <link
      href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.css"
      type="text/css"
      rel="stylesheet"
    />
    <link
      href="//maxcdn.bootstrapcdn.com/bootstrap/4.1.1/css/bootstrap.min.css"
      rel="stylesheet"
      id="bootstrap-css"
    />
    <script src="//maxcdn.bootstrapcdn.com/bootstrap/4.1.1/js/bootstrap.min.js"></script>
    <script src="//cdnjs.cloudflare.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
    <link
      rel="stylesheet"
      href="{{ url_for('static', filename='css/message.css') }}"
    />
  </head>
  <style>
    .grid-container {
      display: grid;
    
    }
  </style>
  <body style="background-color: #ececec">
    <div class="grid-container">
      <div>{% include 'sidebar.html' %}</div>
      <div class="container" style="margin-left: 20%;">
        <div class="header">ADMIN</div>
        <hr class="br_header" />
        <div
          class="block-message-container"
          style="width: 100%; overflow-x: auto; overflow-y: auto"
        >
          <!--  -->
          <div class="block-chat" id="chat">
            {% for message in all_message %}
              {% if message.sender == 'admin' %}
              <div class="admin-msg" style="padding-top: 2%">
                <div class="imgAdmin">
                  <img
                    src="{{url_for('static', filename = 'images/user_profile/default_profile.png')}}"
                    alt=""
                    srcset=""
                    style="width: 70px; height: 70px;border-radius: 50%;"
                  />
                </div>
                <div class="admin-msg-container">
                  <div class="msg-from-admin arrow-left" style="margin-left:2%;">
                    {{ message.message }}
                  </div>
                </div>
              </div>
              {% else %}
              <div class="admin-msg" style="padding-top: 2%;" >
                <div class="admin-msg-container" >

                  <div class="msg-from-customer  arrow-right">
                    {{ message.message }}
                  </div>


                </div>
                <div class="imgCustomer">
                  <img
                    src="{{url_for('static', filename = 'images/user_profile/'+current_user.get_profile().profile_image)}}"
                    alt=""
                    srcset=""
                    style="width: 70px; height: 70px;border-radius: 50%;"
                  />
                </div>
              </div>
              {% endif %}

            {% endfor %}
          </div>
          <!--  -->
        </div>
        <div>
            <div class="input-container">
              <div style="width: 1000px">
                <textarea
                  rows="4"
                  id="input_msg"
                  name="comment"
                  style="
                    border-radius: 12px;
                    border: none;
                    width: 100%;
                    max-width: 100%;
                    padding: 2%;
                  "
                ></textarea>
              </div>
              <div style="width: 100px" onclick="sendMsg()">
                <div class="sendMsg" style="user-select: none;cursor: pointer;">Send</div>
              </div>
            </div>


      
        </div>
      </div>
    </div>
  </body>
</html>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/socket.io/1.7.3/socket.io.min.js"></script>
  <script type="text/javascript">
  var socket = io.connect('http://' + document.domain + ':' + location.port);
  socket.emit('join_room', {customer:'{{current_user.get_id()}}'})
  var objDiv = document.getElementsByClassName("block-message-container")[0];
  objDiv.scrollTop = objDiv.scrollHeight;
  socket.on( 'admin_response', function( data ) {
          // $( 'h3' ).remove()
          $( 'div.block-chat' ).append(`<div class="admin-msg" style="padding-top: 2%">
              <div class="imgAdmin">
                <img
                  src="{{url_for('static', filename = 'images/user_profile/default_profile.png')}}"
                  alt=""
                  srcset=""
                  style="width: 70px; height: 70px"
                />
              </div>
              <div class="admin-msg-container ">
                <div class="msg-from-admin arrow-left" style="margin-left:2%;">
                  `+data.msg+`
                </div>
              </div>
            </div>`)
        var objDiv = document.getElementsByClassName("block-message-container")[0];
        objDiv.scrollTop = objDiv.scrollHeight;
  })
  function sendMsg(){
    var msg = document.getElementById('input_msg').value;
    if (msg != ""){
      $( 'div.block-chat' ).append(`<div class="admin-msg" style="padding-top: 2%">
              <div class="admin-msg-container">
                <div class="msg-from-customer arrow-right">
                  `+msg+`
                </div>
              </div>
              <div class="imgCustomer">
                <img
                  src="{{url_for('static', filename = 'images/user_profile/'+current_user.get_profile().profile_image)}}"
                  alt=""
                  srcset=""
                  style="width: 70px; height: 70px"
                />
              </div>
            </div>`)
      document.getElementById('input_msg').value = "";
      socket.emit('recive_from_user', {"msg":msg,'customer':parseInt("{{current_user.get_id() }}",10),"name":"{{current_user.get_profile().fullname }}","profile_image":"{{current_user.get_profile().profile_image }}"});
      var objDiv = document.getElementsByClassName("block-message-container")[0];
      objDiv.scrollTop = objDiv.scrollHeight;
    }
  }
</script>

project/templates/user/profile.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Oganikku</title>
    <!-- CSS only -->
    <link
      href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css"
      rel="stylesheet"
      integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3"
      crossorigin="anonymous"
    />
    <link
      href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css"
      rel="stylesheet"
      integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3"
      crossorigin="anonymous"
    />
  </head>
  <style>
    .grid-container {
      display: grid;
      grid-template-columns: 18% 82%;
    }
    .card-product {
      width: 350px;
      height: 450px;
      background-color: white;
      margin-left: 5%;
      border-radius: 15px;
    }
    .content-section {
      text-align: center;
    }
    .bg {
      background: url(static/images/testProduct.jpg);
    }
    .img-profile-upload {
      width: 120px;
      height: 120px;
      border-radius: 50px;
    }
    .addCard-btn {
      margin-top: 10%;
      width: 150px;
      height: 38px;
      background-color: white;
      color: black;
      text-align: center;
      border-radius: 20px;
      padding-top: 5px;
    }
    input {
      width: 100%;
      height: 50px;
      border-radius: 18px;
      border-top-style: hidden;
      border-right-style: hidden;
      border-left-style: hidden;
      border-bottom-style: hidden;
      padding-left: 12px;
      color: #7b7b7b;
    }
    .head-content {
      width: 600px;
      height: 220px;
      display: flex;
      padding-top: 8%;
    }
    .content {
      font-family: Century Gothic;
      font-weight: bold;
      color: #7b7b7b;
      width: 100%;
      margin-left: 40px;
    }
    .form-content {
      font-family: Century Gothic;
    }
    .btn-save {
      width: 250px;
      height: 50px;
      background-color: #a9d18e;
      text-align: center;
      font-family: Century Gothic;
      font-size: 20px;
      border: none;
      margin-left: auto;
      margin-right: auto;
      border-radius: 18px;
      display: flex;
      justify-content: center;
      align-items: center;
      margin-top: 8%;
    }
    #display_image {
      min-width: 100px;
      max-height: 100px;
      border-radius: 50%;
      border: 1px solid black;
      background-position: center;
      background-size: cover;
    }
    .chooseFile {
      padding: 5px;
      color: white;
      background-color: #a9d18e;
      text-align: center;
      border-radius: 8px;
      margin-top: 10px;
      font-family: Century Gothic;
      cursor: pointer;
    }
  </style>
  <body style="background-color: #ececec">
    <div class="grid-container">
      <div>{% include 'sidebar.html' %}</div>
      <div
        style="
          width: 100%;
          margin-left: auto;
          margin-right: auto;
          display: flex;
          justify-content: center;
        "
      >
        <div style="height: 100vh">
          <div class="head-content">
            <div>
              <div
                id="display_image"
                style="
                  height: 100px;
                  width: 100px;
                  text-align: center;
                  margin-left: auto;
                  margin-right: auto;
                "
              ></div>
              <form id="update_image_profile" enctype="multipart/form-data">
                <input
                  type="file"
                  name = "file"
                  id="image_input"
                  style="margin-top: 5%; display: none"
                  title=" "
                />
              </form>
              <label class="chooseFile" for="image_input">Choose file </label>
            </div>

            <div class="content">
              <div style="font-size: 35px">{{current_user.get_profile().fullname}}</div>
              <div style="font-size: 20px">Nongchok,BKK</div>
            </div>
          </div>
          <div class="form-content">
            <div
              style="
                margin-top: 1%;
                width: 600px;

                text-align: left;
              "
            >
              <form action="{{url_for('user.update_profile')}}" method="POST">
                <p style="font-size: 20px; margin-bottom: 2px">Username</p>
                <input
                  type="text"
                  name="username"
                  class="no-outline"
                  style="margin-top: 2%"
                  placeholder="Enter Something"
                  value="{{current_user.get_profile().username}}"
                />
                <p style="font-size: 20px; margin-bottom: 2px; margin-top: 3%">
                  Full Name
                </p>
                <input
                  type="text"
                  name="fullname"
                  class="no-outline"
                  style="margin-top: 2%"
                  placeholder="Enter Something"
                  value="{{current_user.get_profile().fullname}}"
                />
                <p style="font-size: 20px; margin-bottom: 2px; margin-top: 3%">
                  Email
                </p>
                <input
                  type="text"
                  name="email"
                  class="no-outline"
                  style="margin-top: 2%; font-weight: bold"
                  placeholder="Enter Something"
                  value="{{current_user.get_profile().email}}"
                  readonly
                />

                <button type="submit" class="btn-save" style="color: white">
                  Save
                </button>
              </form>
            </div>
          </div>
        </div>
      </div>
    </div>
  </body>
</html>
<script>
const image_input = document.querySelector("#image_input");
var uploaded_image = ""
image_input.addEventListener('change', function() {
  const reader = new FileReader();
  form = document.getElementById("update_image_profile");
  reader.addEventListener('load', () => {
    uploaded_image = reader.result;
    document.querySelector("#display_image").style.backgroundImage = `url(${uploaded_image})`;
    const formData = new FormData(form);  // grab the data inside the form fields
    
    fetch('{{url_for("user.upload_image_profile")}}', {   // assuming the backend is hosted on the same server
        method: 'POST',
        body: formData,
    }).then(function(response) {
        // do something with the response if needed.
        // If you want the table to be built only after the backend handles the request and replies, call buildTable() here.
    });
  });
  reader.readAsDataURL(this.files[0]);
});
setDefaultImg();
function setDefaultImg(){
  if(uploaded_image = " "){
    document.querySelector("#display_image").style.backgroundImage = `url(${"{{url_for('static', filename = 'images/user_profile/'+current_user.get_profile().profile_image)}}"})`;
  }
}
</script>

project/templates/user/register.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Oganikku</title>
    <!-- CSS only -->
<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">
</head>
<style>
    body{
        margin: 0px;
    }
    .bg-container{
    background: rgba(0,0,0,0.7) url(static/images/loginbg.jpg);
    background-blend-mode: darken;
    height: min-content;
    width: 100%;
    background-repeat: no-repeat;
    background-size: 100vw 105vw;
    padding-bottom: 4%;
    }
    .form-container{
        padding-top: 3%;
    }
    input {
        border-top-style: hidden;
        border-right-style: hidden;
        border-left-style: hidden;
        border-bottom-style: solid;
        border-bottom-color: white;
        background-color: transparent;
        width: 100%;
        height: 45px;
      }
      
      .no-outline:focus {
        outline: none;
   
      }
      .btn-create{
        width: 400px;
    background-color: #A9D18E;
    padding: 20px;
    border-radius: 30px;
      }
      .btn-create-account{
        margin-top:2%;
         font-family: Century Gothic;
         font-weight: bold;
         font-size:20px;
         text-align: center;
         color: white;
         cursor: pointer;
      }
</style>
<body > 
   <div class="bg-container">
        <div class="form-container">
           
                <div style="color:white;text-align: center;font-size: 50px;font-weight: bold;font-family:Century Gothic;">
                    Create Account
                </div>
                <center> 
                    <form method="POST" action="/register">
                <div style="
                    margin-top:1%;
                    width:470px;
    
                    text-align: left;"
                    >
                    <p style="color:white;font-size: 20px;margin-bottom:2px;">Username</p>
                    <input type="text" name="username" class="no-outline" placeholder="Username"  style="color: white;"  required>
                    <p style="color: white;font-size: 20px;margin-bottom:2px;margin-top:3%;">Fullname</p>
                    <input type="text" name="fullname" class="no-outline" placeholder="Fullname" style="color:white;" required >
                    <p style="color: white;font-size: 20px;margin-bottom:2px;margin-top:3%;">Email</p>
                    <input type="email"name="email" class="no-outline" placeholder="Email" style="color:white;" required>
                    <p style="color: white;font-size: 20px;margin-bottom:2px;margin-top:3%;">Password</p>
                    <input type="password" name="password" type="password" class="no-outline" placeholder="Password" style="color:white;" required>
                    <p style="color: white;font-size: 20px;margin-bottom:2px;margin-top:3%;">Confirm Password</p>
                    <input type="password" name="confirm_password" type="password" class="no-outline" placeholder="Confirm Password" style="color:white;" required>
                    <div style="width: 100%;">
                        {% with messages = get_flashed_messages() %}
                        {% if messages %}
                            <ul class=flashes style="margin-top:2%;text-align: center;color: red; font-family: Century Gothic;font-weight: bold;padding-left: 0px;">
                            {{ messages[0] }}
                            </ul>
                        {% endif %}
                        {% endwith %}
                    </div>



            <div style="display: flex;justify-content: center;">

                      
            <button class="btn-create" style="margin-top:3%;color:white;font-size:20px;" type="submit" >
                Get Start
            </button>

             </div>  
                  </form>
                <a href="{{url_for('user.login')}}" style="text-decoration: none;">
                    <div class="btn-create-account">
                        Already Have Account ?
                    </div>
                </a>
                </div>
    
         
        </center>
        </div>
    </div>

</body>
</html>
<script>

</script>